
local perlin = love.filesystem.read("perlin2d.glsl")
local shader_code = perlin..[[
vec4 color1 = vec4(0.0,0.0,0.0,1.0);
extern vec2 offset = vec2(0.0, 0.0);
vec4 effect(vec4 color, Image image, vec2 uvs, vec2 screen_coords)
{
	vec4 pixel = Texel(image, uvs);
	float avg = (pixel.r + pixel.g + pixel.b)/3.0;
	//return vec4(avg, avg, avg, pixel.a);
	
	//if(avg < 0.1)
	//{
		//float x = fract(sin(dot(st.xy, vec2(12.9898,78.233)))* 43758.5453123);	
		//float x = 0.1;
		//return vec4(x, x, x, 1.0);
		screen_coords = screen_coords + offset;
		
		//number noise = perlin2d(screen_coords / 128.0);
		number noise = perlin2d(screen_coords / 180.0);
		
		noise = noise * 0.5 + 0.5;
		float c = noise * ((1.0 - avg)*(1.0 - avg)) * 0.05;
		return vec4(pixel.r + c, pixel.g + c, pixel.b + c, 1.0);
	//}
	//else
	//{
		//return pixel;
	//}
}
]]



local shader = love.graphics.newShader(shader_code)
local fogCanvas = love.graphics.newCanvas(love.graphics.getWidth(), love.graphics.getHeight())
local timer = 0
local direction = 1
local smoothDirection = 1
function fog_update(dt)
	smoothDirection = smoothDirection + (direction - smoothDirection) * dt
	timer = timer + dt * 100 * smoothDirection
	if(timer > 500) then
		direction = -1
	end
	
	if(timer < 0) then
		direction = 1
	end

	local px, py = get_cam()
	px, py = px*4, py*4
	px, py = px - timer, py - timer
	shader:send("offset", {px, py})
end

function set_fog()
	love.graphics.setShader(shader)
end

function fog_resize()
	love.graphics.newCanvas(love.graphics.getWidth(), love.graphics.getHeight())
	love.graphics.setCanvas(fogCanvas)
	love.graphics.rectangle("fill", 0,0, love.graphics:getWidth(), love.graphics:getHeight())
	love.graphics.setCanvas()
end

fog_resize()

function fog_draw()
	--love.graphics.setShader(shader)
	--love.graphics.draw(fogCanvas)
	--love.graphics.setShader()
end