local models = {}

function models_load()
	new_model("models/body", "body")
	new_model("knocked/body.png", "knockedBody", 6)
	new_model("models/weapon2", "weapon2")
	new_model("head.png", "head", 8)
	new_model("models/head", "head2")
	new_model("models/shoulder", "shoulder")
	new_model("models/redShoulder", "redShoulder")
	new_model("models/weapon", "weapon", 3)
	new_model("arm.png","arm",4)
	new_model("models/leftZombArm","leftZombArm")
	new_model("models/rightZombArm","rightZombArm")
	new_model("models/leftPlayerArm","leftPlayerArm")
	new_model("models/rightPlayerArm","rightPlayerArm")
	new_model("arm2.png","arm2",4)
	new_model("knocked/zarm2.png","hand2",4)
	new_model("knocked/arm2.png","hand",4)
	new_model("models/test", "test")
	new_model("models/helmet", "helmet")
	new_model("models/redHelmet", "redHelmet")
	new_model("models/armour", "armour")
	new_model("models/redArmour", "redArmour")
	new_model("models/castle", "castle")
	new_model("models/fountain", "fountain")
end

function new_model(file,model,depth)
	models[model] = {}
	local m = models[model]
	m.depth = 0

	local info = love.filesystem.getInfo(file)
	if(info.type == "directory") then
		m.imgs = {}
		m.imgDatas = {}
		local files = love.filesystem.getDirectoryItems(file)
		for i = 1, #files do
			m.imgs[i] = love.graphics.newImage(file.."/"..i..".png")
			m.imgDatas[i] = love.image.newImageData(file.."/"..i..".png")
		end

		-- rotated version
		m.rotImgs = {}
		local datas = {}

		for z = 1, m.imgs[1]:getWidth() do
			datas[z] = love.image.newImageData(#m.imgs, m.imgs[1]:getHeight())
		end

		for y = 0, m.imgs[1]:getHeight() - 1 do
			for x=0,m.imgs[1]:getWidth() - 1 do
				for z = 1, #m.imgs do
					--local img = m.imgs[z]
					local r, g, b, a = m.imgDatas[z]:getPixel(x, y)

					datas[x+1]:setPixel(z-1,y,r,g,b,a)
				end
				--local r, g, b = img:getPixel(x,y)
				--data:setPixel(z-1,y,r,g,b)

			end
		end



		for z = 1, #datas do
			m.rotImgs[z] = love.graphics.newImage(datas[z])
		end

	elseif(info.type == "file") then
		m.img = love.graphics.newImage(file)
		m.depth = depth
	end
	table.insert(models,m)
end

function model_draw(model,x,y,angle,sx,sy,ox,oy,height,rotated)
	--love.graphics.print("MODEL",x, y)
	local m = models[model]
	if(m.img) then
		for i=1,m.depth do
			local img = models[model].img
			add_drawable("img", {img = img, x=x,y=y - i,angle=angle,sx=sx,sy=sy,ox=ox*img:getWidth(),oy=oy*img:getHeight(),height=i+height})
			--love.graphics.draw(img,x,y - i,angle,sx,sy,ox,oy)

		end
	else
		if(rotated) then
			for i=1,#m.rotImgs do
				local img = m.rotImgs[i]
				add_drawable("img", {img = img, x=x,y=y - i +#m.rotImgs/2,angle=angle+math.pi,sx=sx,sy=sy,ox=ox*img:getWidth(),oy=oy*img:getHeight(),height=i+height-#m.rotImgs/2})
				--love.graphics.draw(img,x,y - i,angle,sx,sy,ox,oy)
			end
		else
			for i=1,#m.imgs do
				local img = m.imgs[i]
				add_drawable("img", {img = img, x=x,y=y - i,angle=angle,sx=sx,sy=sy,ox=ox*img:getWidth(),oy=oy*img:getHeight(),height=i+height})
				--love.graphics.draw(img,x,y - i,angle,sx,sy,ox,oy)
			end
		end
	end
end